#!/usr/bin/perl


# Some variables

#path with trailing / to script and config
$logcheckpath="/root/smtpblock-1.0.0/";

#name of whitelist file
$file_whitelist=$logcheckpath."smtpblock.whitelist";

$logfilepath="/var/log/mail";


#------------------------------------------------------------------
# Dont change anything from here unless you know what you do
#------------------------------------------------------------------

$mode="run";


sub head() {
	print "\n---------------------------\n";
	print "This is smtpblock.pl V1.0.1\n";
	print "http://peters-webcorner.de\n";
	print "---------------------------\n\n";
}

if (($ARGV[0] ne "") && ($ARGV[0] ne "debug") && ($ARGV[0] ne "clean") ) {
	#any parameter prints help screen
	head();
	print "you can use 'smtpblock.pl debug', 'smtpblock clean'  or 'smtpblock.pl' without any parameters\n";
	exit 0;

}

if ($ARGV[0] eq "debug") {
	#debug parameter turns on debug mode
	head();
	print "debug mode on...\n";
	$mode="debug";

}

if (-e $file_whitelist) {
	if($mode eq "debug") {
		print "whitelist found...\n";
	}
} 
if ($ARGV[0] eq "clean") {
	if (-e $logcheckpath."bl.db" ) {
		if($mode eq "debug") {
			print "blacklist found...deleting\n";
		}
		unlink $logcheckpath."bl.db";
		$cmd = "\/etc\/init.d\/masq start > \/dev\/null";
		system $cmd;
	} 
exit 0;
}

# reading in the whitelist
$read=0;
open(ADR, "<$file_whitelist");
while(<ADR>)
{
	chop($_);
	if(length($_) > 1) {
		if (substr($_,0,1) ne "#") 
		{
		$read++;
		push @whitelisted, $_;
		}
	}
}
close(ADR);
if ($read > 0) {
	if($mode eq "debug") {
		print $read." entries in whitelist found\n";
	}
}
else
{
	if($mode eq "debug") {
		print "no entries in whitelist found, may be not normal...\n";
	}
}


# reading in the logfile list

#check each logfile
	$thisfile = $logfilepath;
	$outtext="";
	$noffset="";
	$offset;
	$jumpover;
	if($mode eq "debug") {
		print "processing ".$thisfile."\n";
	}
	if(-e $thisfile) 
	{
		$useoffset=0;
		$thisoffset="";
		if(-e $thisfile.".offset.smtpblock") {
			if($mode eq "debug") {
				print "using ".$thisfile.".offset.smtpblock\n";
			}
			$useoffset=1;
			open(OFF,"<$thisfile.offset.smtpblock");
			while(<OFF>)
			{
				$offset=$_;
				if($mode eq "debug") {
					print "offset is $_\n";	
				}
			}
			close(OFF);
		}	
		$jumpover=1;	
		check();
		if($jumpover==1) {
			unlink($thisfile.".offset.smtpblock");
			if($mode eq "debug") {
				print "offset not found, reparsing without offset\n";	
			}
			$jumpover=0;
			$offset="";
			check();
		}
		if ($outtext ne "") {
			$Jetztwert = time();
			$Jetztzeit = localtime($Jetztwert);
			$mailer = '/usr/sbin/sendmail';
        	        $Sender = 'root@dns1.mapproject.de';
 #       	        open(MAIL, "|$mailer -t") || die "Can't open $mailer!\n";
#	                print MAIL "To: peter\@yellowfox.net\n";
#        	        print MAIL "Subject: ($thisfile) violation report $Jetztzeit\n\n\n";
#        	        print MAIL $outtext;
#	                close(MAIL);
		}
		if ($noffset ne "") {
			if($mode eq "debug") {
				print "new offset written in ".$thisfile.".offset.smtpblock\n";	
			}
			open(ADR, ">$thisfile.offset.smtpblock");
			       print ADR $noffset;
			close(ADR);
		}
	}
	else
	{
		print STDERR "logfile $thisfile not found...ignoring\n";
	}	

#exiting, all is done
exit 0;


sub check() {
	# checks the logfile itself
	open(LOG,"<$thisfile");
	while(<LOG>) 
	{
		if($jumpover==0) {
			$wl=0;
			if ($_ =~/lost\ connection\ after/) {
				($m1,$thism) = split(/lost\ connection\ after/,$_);	
				($th,$ip1) = split(/\[/,$thism);
				($ip,$ip2) = split(/\]/,$ip1);
				foreach $wltext (@whitelisted)
				{
					if($ip =~/$wltext/) {
						$wl=1;
					}				
				}
				if($wl==0) {
					#take action
					if($mode eq "debug") {
						print "blacklist ".$ip."\n";
					}
					open(ADR, ">>$logcheckpath"."bl.db");
						$thist = time();
						print ADR "$ip-$thist\n";
					close(ADR);
					open 
					$command = "\/usr\/sbin\/iptables -A INPUT --source ".$ip." -p tcp --destination-port 25 -j DROP";
					system $command;
					$command1 = "\/bin\/logger -p mail.notice \"smtpblock: BLOCKED host ".$ip."\"";
					system $command1;    
				}
				
			}
			#warning: 118-168-194-62.dynamic.hinet.net[118.168.194.62] sent non-SMTP command
			$wl=0;
			if ($_ =~ /sent\ non-SMTP\ command/) {
				($m1,$thism) = split(/warning/,$_);
				($m1,$ip1) = split(/\[/,$thism);
				($ip,$ip2) = split(/\]/,$ip1);
				foreach $wltext (@whitelisted)
				{
					if($ip =~/$wltext/) {
						$wl=1;
					}				
				}
				if($wl==0) {
					#take action
					if($mode eq "debug") {
						print "blacklist ".$ip." NONSMTP block\n";
					}
					open(ADR, ">>$logcheckpath"."bl.db");
						$thist = time();
						print ADR "$ip-$thist-NONSMTP\n";
					close(ADR);
					open 
					$command = "\/usr\/sbin\/iptables -A INPUT --source ".$ip." -p tcp --destination-port 25 -j DROP";
					system $command;
				}
			}
		}
		$noffset = substr($_,0,15,);
		if(substr($_,0,15) eq $offset) {
			$jumpover=0;
			if($mode eq "debug") {
				print "offset found\n";	
			}
		}
	}
	close(LOG);
}


